import { MutatorFunc } from './mutation';
import { FactoryFunc } from './factory';
import { AggregateRoot, DomainEventEmitter, Entity, Repository } from './index';
export declare class AggregateRootImpl<T extends Entity> implements AggregateRoot<T>, DomainEventEmitter {
    private __currentPromise;
    private __error;
    private __state;
    private __markedForDeletion;
    private readonly __events;
    private readonly __previousVersion;
    readonly state: Promise<T | null>;
    readonly error: Promise<Error | null>;
    readonly version: number;
    readonly events: Promise<{
        name: string;
        data: any;
    }[]>;
    constructor(state?: T | Error, version?: number);
    mutation<TCommand>(mutator: MutatorFunc<T, TCommand>): (cmd: TCommand) => this;
    factory<TCommand, TCreated extends Entity>(factoryFunc: FactoryFunc<T, TCommand, TCreated>): (cmd: TCommand) => Promise<AggregateRoot<TCreated>>;
    'delete'(): this;
    commit<TActual extends Entity>(repo: T extends TActual ? Repository<T> : never): Promise<T>;
    emit<T extends Record<string, any>, K extends keyof Pick<T, string>>(name: K, data: unknown extends T[K] ? never : T[K]): void;
}
