import { DomainEvent } from './index';
export interface CoreEvents {
    AggregateDeleted: {
        types: string[];
    };
}
declare type PossiblyDomainEvent<T extends Record<string, any>, K extends keyof Pick<T, string>> = unknown extends T[K] ? never : DomainEvent<T[K]>;
declare type Handler<T extends Record<string, any>, K extends keyof Pick<T, string>> = (ev: PossiblyDomainEvent<T, K>) => void | Promise<any>;
export declare function handle<T extends Record<string, any>, K extends keyof Pick<T, string>>(name: K, handler: Handler<T, K>): (id: string, data: T[K]) => void | Promise<any>;
export declare function emit(name: string, ev: DomainEvent<any>): Promise<void>;
export declare function emitImmediate<T extends Record<string, any>, K extends keyof Pick<T, string>>(id: string, name: K, data: unknown extends T[K] ? never : T[K]): Promise<void>;
export {};
